<?php

namespace NoccyLabs\Mercureact\Http\Middleware;

use Psr\Http\Message\ServerRequestInterface;
use React\Http\Message\Response;
use React\Promise\Promise;
use React\Promise\PromiseInterface;

class NotFoundHandler
{
    /**
     * Resolves unhandled requests with a 404 error
     * 
     * @param ServerRequestInterface $request
     * @return PromiseInterface
     */
    public function __invoke(ServerRequestInterface $request): PromiseInterface
    {
        return new Promise(
            function ($resolve) { 
                $resolve(Response::plaintext("Not found")->withStatus(404));
            }
        );
    }

}